{******************************************************************************}
{ TWEBUPDATE component sample project                                          }
{                                                                              }
{ Uses update control file at : http://www.tmssoftware.com/update/sampapp.inf  }
{                                                                              }
{ written by                                                                   }
{    TMS Software                                                              }
{    copyright  1998-2007                                                     }
{    Email : info@tmssoftware.com                                              }
{    Web   : http://www.tmssoftware.com                                        }
{                                                                              }
{ The source code is given as is. The author is not responsible                }
{ for any possible damage done due to the use of this code.                    }
{ The component can be freely used in any application. The source              }
{ code remains property of the writer and may not be distributed               }
{ freely as such.                                                              }
{******************************************************************************}

unit Usampapp;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  wupdate, StdCtrls, uproxy, ExtCtrls, uselcomp, ComCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Button1: TButton;
    WebUpdate1: TWebUpdate;
    Threaded: TCheckBox;
    ProgressBar1: TProgressBar;
    Label2: TLabel;
    Button2: TButton;
    Dlgs: TCheckBox;
    Image1: TImage;
    StatusBar1: TStatusBar;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure WebUpdate1Status(Sender: TObject; statusstr: String;
      statuscode, errcode: Integer);
    procedure WebUpdate1AppRestart(Sender: TObject; var allow: Boolean);
    procedure WebUpdate1FileProgress(Sender: TObject; filename: String;
      pos, size: Integer);
    procedure Button2Click(Sender: TObject);
    procedure WebUpdate1GetFileList(Sender: TObject; list: TStringList);
    procedure FormCreate(Sender: TObject);
    procedure WebUpdate1AppDoClose(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  WebUpdate1.PostUpdateInfo.Data :=
    WebUpdate1.PostUpdateInfo.Data + '&TIME='+FormatDateTime('dd/mm/yyyy@hh:nn',Now)+'&OS='+WebUpdate1.GetOSVersion+'&DEV='+WebUpdate1.GetInstalledIDEs;

  if Threaded.Checked then
    WebUpdate1.DoThreadupdate
  else
    WebUpdate1.DoUpdate;
end;

procedure TForm1.WebUpdate1Status(Sender: TObject; StatusStr: String;
  Statuscode, Errcode: Integer);
begin
  if Dlgs.Checked then
    MessageDlg(StatusStr,mtInformation,[mbok],0);

  if StatusCode = WebUpdateNoNewVersion then
    MessageDlg('No new version available',mtinformation,[mbok],0);

  if StatusCode = WebUpdateNotFound then
    MessageDlg(StatusStr + #13'Update discontinued',mtinformation,[mbok],0);

  StatusBar1.SimpleText := StatusStr;
end;

procedure TForm1.WebUpdate1AppRestart(Sender: TObject; var allow: Boolean);
begin
  Allow := MessageDlg('Shutting down application to update executable files ?',mtConfirmation,[mbYes,mbNo],0)=mrYes;
end;

procedure TForm1.WebUpdate1FileProgress(Sender: TObject; filename: String;
  pos, size: Integer);
begin
  progressbar1.max:=size;
  progressbar1.position:=pos;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  proxy:tproxy;
begin
  proxy:=tproxy.Create(self);
  with proxy do
  begin
    edit1.text:=webupdate1.proxy;
    edit2.text:=webupdate1.proxyuserid;
    edit3.text:=webupdate1.proxypassword;
  end;
  try
  if proxy.showmodal=mrok then
  begin
    webupdate1.proxy:=proxy.edit1.text;
    webupdate1.proxyuserid:=proxy.edit2.text;
    webupdate1.proxypassword:=proxy.edit3.text;
  end;
  finally
   proxy.free;
 end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  if WebUpdate1.NewVersionAvailable then
    ShowMessage('A new version is available !');

  ProgressBar1.Position := 0;
end;

procedure TForm1.WebUpdate1GetFileList(Sender: TObject; list: TStringList);
var
  i:integer;
  selcomp: TSelcomp;
  mr:integer;
begin
  selcomp := TSelcomp.create(self);
  try
    SelComp.Checklist.items.Assign(list);

    for i := 1 to list.Count do
      SelComp.Checklist.Checked[i - 1] := True;

    mr := selcomp.ShowModal;

    for i := 1 to list.count do
    begin
      if (mr = mrCancel) or
        (not SelComp.checklist.Checked[i - 1]) then
          list.strings[i-1] := '';
    end;
  finally
    SelComp.Free;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Image1.Picture.loadfromfile('logo.bmp');
  WebUpdate1.PostUpdateInfo.Action := '/asp/webupd.asp';
  WebUpdate1.PostUpdateInfo.Server := 'www.tmssoftware.com';
  WebUpdate1.PostUpdateInfo.Data := 'REGLOGIN=Sample&REGCODE=1234';
  WebUpdate1.PostUpdateInfo.Enabled := true;
end;

procedure TForm1.WebUpdate1AppDoClose(Sender: TObject);
begin
  Close;
end;

end.
